Option Explicit On
Option Strict On

Imports System.IO
Imports System.Query
Imports DemoData
Imports DemoData.Dumper
Imports System.Xml.XLinq
Imports MayVb.ExtensionModule

Module Module1

    Sub Main()
        'start: 
        For Each fi As FileInfo In New DirectoryInfo("C:\windows").GetFiles
            If fi.Extension = ".exe" Or fi.Extension = ".log" Then
                Console.WriteLine(fi.Name)
            End If
        Next

        'Becomes:
        'Dim results = From fi As FileInfo In New DirectoryInfo("C:\windows").GetFiles, _
        '    e As FileType In FileTypes.Load _
        '    Where (fi.Extension = ".exe" Or fi.Extension = ".log") And _
        '        (fi.Extension = e.Extension) _
        '    Select New {FileName := fi.Name, LastAccess := fi.LastAccessTime, extension := e.Description}

        'Dim results = From c In System.Enum.GetNames(GetType(ConsoleColor)) _
        '    Where c.StartsWith("Dark") _
        '    Select c

        'Dumper.Write(results)
        Console.ReadLine()
    End Sub

    Public Sub FileDemo()
        Dim result = _
          From f In New DirectoryInfo("C:\Windows").GetFiles(), _
                  e As FileType In FileTypes.Load _
            Where (f.Extension = ".exe" Or f.Extension = ".log") And f.Extension = e.Extension _
            Select New {f.Name, f.LastAccessTime, e.Description}

        result.Write()
        Console.WriteLine(result)
    End Sub
    Public Sub ReflectionDemo()
        Dim colors = From s In [Enum].GetNames(GetType(System.ConsoleColor)) _
            Where s.StartsWith("Dark") _
            Select s _
            Order By s Descending
        Dumper.Write(colors)
    End Sub
    Public Sub XLinqDemo()
        Dim CodeCamp As String = "Jacksonville Code Camp"
        Dim val = <XLinqRocksBecause version=<%= CodeCamp %>>
                      <LinqEssentials>
                          <Category>LINQ</Category>
                          <Category>DLINQ</Category>
                          <Category>XLINQ</Category>
                      </LinqEssentials>
                      <LanguageFeatures forDate=<%= Today() %>>
                          <release version="2.0">
                              <feature>Generics</feature>
                              <feature>Iterators</feature>
                              <feature>Anonymous Delegates</feature>
                              <feature>Nullable Types</feature>
                          </release>
                          <release version="3.0">
                              <feature>Implicit Types</feature>
                              <feature>Extension methods</feature>
                              <feature>Lambda Expressions</feature>
                              <feature>Object initializers</feature>
                              <feature>Anonymous Types</feature>
                              <feature>Expression Trees</feature>
                          </release>
                          <release version="9.0">
                              <feature>dynamic interfaces</feature>
                              <feature>dynamic identifiers</feature>
                              <feature>XML Literals</feature>
                          </release>
                      </LanguageFeatures>
                  </XLinqRocksBecause>
        Console.Write(val)

        Dim filter = val.Descendants("feature")
        filter.Write()
    End Sub
End Module


